#!/usr/sbin/perl 
#
# Deppends on: sel2sw_server.perl ~/prog/rep/ @warbler (191) 28/6/99
#
# Miguel A. Andrade - for the repeats server
#
# Version 2.0: Includes E-value field from input file
#              Separates the from-to in a different field
# 30/9/99
#========================================================

require "./cgi-lib.pl";

$row = '/biocomp/bork1/bin/row';
$column = '/biocomp/bork1/bin/column';

# Start off by reading and parsing the data.  Save the return value.
# We could also save the file's name and content type, but we don't
# do that in this example.
$ret = &ReadParse;

$repeat = $in{'repeat'};
$method = $in{'method'};

$results = 'results/sw_results.rdb';


if ($method eq 'Pfam + REP'){
  $method_message = "Proteins detected by both Pfam and REP";
  @lines = `cat $results | $row rep_id mat $repeat | $row pfam ne '' | $row rep ne ''`;
} elsif ($method eq 'Only Pfam'){
  $method_message = "Proteins detected by Pfam but not by REP";
  @lines = `cat $results | $row rep_id mat $repeat | $row pfam ne '' | $row rep eq ''`;
} elsif ($method eq 'Only REP'){
  $method_message = "Proteins detected by REP but not by Pfam";
  @lines = `cat $results | $row rep_id mat $repeat | $row pfam eq '' | $row rep ne ''`;
} else {
  # default get all
  $method_message = "Complete set";
  @lines = `cat $results | $row rep_id mat $repeat`;
}


# output

print "Content-type: text/html\n\n";
print "<BODY BGCOLOR=#FFFFFF TEXT=#008800 LINK=#808800>\n";
print "<TITLE>Analysis of $repeat repeats in SwissProt</TITLE>\n";
print "<H1>Analysis of $repeat repeats in SwissProt</H1>\n";
print "<H3>$method_message</H3>\n";

print "<TABLE BORDER>\n";
print "<TR>\n";
print "<TH>Id</TH><TH>PFAM</TH><TH>REP</TH>\n";
print "<TH>from</TH><TH>to</TH><TH>E-value</TH><TH>sequence</TH>\n";
print "</TR>\n";

$some = 0;
$counter = 2;
foreach $line(@lines){
  
  if ($line =~ /^\#/){
    next;
  }
  if ($counter > 0){
    $counter--;
    next;
  }
  chop($line);
  @words = split(/\t/,$line);

  # reformat repeat list
  $repeat_list = $words[4];
  chop($repeat_list);

  # removed Version 2.0
  # $repeat_list =~ tr/;/\n/;

  $some = 1;

  # added Version 2.0
  undef(@repeats);
  @repeats = split(/\;/, $repeat_list);
  $num_repeats = scalar(@repeats);

  # modified Version 2.0
  print "<TR>\n";  
  print "<TD ROWSPAN=$num_repeats><A HREF = http://www.embl-heidelberg.de/srs5bin/cgi-bin/wgetz?-e+[SWISSPROT-ID:'$words[0]']>\n";
  print "$words[0]</A></TD>\n";
  print "<TD ROWSPAN=$num_repeats>$words[2]</TD>\n";
  print "<TD ROWSPAN=$num_repeats>$words[3]</TD>\n";
  for ($i = 0; $i < $num_repeats; $i++){
    # get from and to
    @words = split(/\:/, $repeats[$i]);
    $pos = $words[0];
    ($from, $to) = split(/\-/, $pos);
    $evalue = $words[1];
    $sequence = $words[2];
    print "<TD>$from</TD><TD>$to</TD>\n";
    printf "<TD>%.2e</TD>", $evalue;
    print "<TD>$sequence</TD>\n";
    print "</TR>\n";  
  }
  print "<TR><TD></TD><TD></TD><TD></TD><TD></TD><TD></TD><TD></TD><TD></TD></TR>\n";
}

print "</TABLE><P>\n";

if ($some == 0){
  print "None were found<P>\n";
}

print "<HR>\n";
print "<A HREF=http://www.embl-heidelberg.de/~andrade/papers/rep/>[Appendix Home]</A>\n";
print "<A HREF=http://www.embl-heidelberg.de/~andrade/index.html>[Andrade Home]</A>\n";
print "<A HREF=http://www.bork.embl-heidelberg.de/>[Bork Group]</A>\n";
















