#!/usr/bin/perl
use URI::Escape;

$system = 'mohamed';
#$system = 'miguel_mainz';


# correspondences between repeat name and the *.prf *.for file names
%basic_name = (
               'ANK', 'ank2',
               'ARM', 'arm',
               'HAT', 'hat',
               'HEAT', 'heat',
	       'HEAT_AAA', 'heat_aaa',
	       'HEAT_ADB', 'heat_adb',
	       'HEAT_IMB', 'heat_imb',
               'KELCH', 'kelch',
               'LRR', 'LRR_typ',
               'PFTA', 'pfta',
               'PFTB', 'pftb3',
               'RCC1', 'rcc1',
               'TPR', 'tpr',
               'WD40', 'wd3',
);

%e_value = (
               'ANK', 1e-5,
               'ARM', 1e-8,
               'HAT', 1e-4,
               'HEAT', 1e-6,
	       'HEAT_AAA', 1e-5,
	       'HEAT_ADB', 1e-6,
	       'HEAT_IMB', 1e-6,
               'KELCH', 1e-4,
               'LRR', 1e-4,
               'PFTA', 1e-4,
               'PFTB', 1e-5,
               'RCC1', 1e-5,
               'TPR', 1e-4,
               'WD40', 1e-4,
);

%min_rep = (
               'ANK', 1,
               'ARM', 3,
               'HAT', 3,
               'HEAT', 4,
	       'HEAT_AAA', 5,
	       'HEAT_ADB', 4,
	       'HEAT_IMB', 5,
               'KELCH', 3,
               'LRR', 2,
               'PFTA', 4,
               'PFTB', 2,
               'RCC1', 3,
               'TPR', 3,
               'WD40', 3,
);


require "./cgi-lib.pl";


$row = '/biocomp/bork1/bin/row';
$column = '/biocomp/bork1/bin/column';


# Start off by reading and parsing the data.  Save the return value.
# We could also save the file's name and content type, but we don't
# do that in this example.
$ret = &ReadParse;


$format = $in{'format'};
$orig_sequence = $in{'sequence'};
$debug = $in{'debug'};
$repeat_type = $in{'repeat_type'};

if ($repeat_type ne "ALL") {
	%basic_name = ($repeat_type, $basic_name{$repeat_type});
}


# give me all flag
$give_me_all = $in{'all'};


# clean the sequence
$sequence = uri_unescape($orig_sequence);

$seq_count = 0;

#$error = $basic_name{"ANK"};
#&sub_error;
#exit;


while ($sequence =~ /(>)([^>\n ]*) ?([^>\n]*)\n([^>]*)/sg) {
	$headers[$seq_count] = $2;
	$headers_complete[$seq_count] = $1 . $2 . " " . $3;
	
	for ($i = length($headers[$seq_count]); $i < 30; $i++) {
		$white_spaces[$seq_count] .= "&nbsp;";
	}

	$sequences[$seq_count] = $4;
	
	$seq_count++;

}

if ($seq_count == 0) {
	$headers[0] = "";
	$headers_complete[0] = "";
	$sequences[0] = $sequence;
	$seq_count = 1;
}

for ($seq_number = 0; $seq_number < $seq_count; $seq_number++) {
	$sequences[$seq_number] =~ tr/[a-z]/[A-Z]/;
	$sequences[$seq_number] =~ s/[^A-Z-]//g;
}

#$error .=$seq_count. "<br/>" . $headers[0] . "<br/>" . $sequences[0];
#&sub_error;
#exit;

for ($seq_number = 0; $seq_number < $seq_count; $seq_number++) {
	$sequence = $sequences[$seq_number];
	$repeat_list[$seq_number] = {};

	$sequence =~ tr/[a-z]/[A-Z]/;
	$sequence =~ s/\W//g;
	$sequence =~ s/\d//g;

	if ($sequence eq '') {
	$error = "You have to provide a protein sequence";
	&sub_error;
	exit;
	}

	$length = length($sequence);
	if ($length > 20000) {
	$error = "Sequence is too long (> 20 000 characters). Submit fragments.";
	&sub_error;
	exit;
	} elsif ($length < 20) {
	$error = "Sequence is too short (< 20 characters). I will not find a repeat there.";
	&sub_error;
	exit;
	}



	$time = time;
	$internal_id = $time;

	# make the sequence in a nice 60 column format
	$i = 0;
	$j = 0;
	while ($i < (length($sequence) - 60)) {
	$nice_seq[$j++] = substr($sequence, $i, 60);
	$i += 60;
	}
	$nice_seq[$j++] = substr($sequence, $i, length($sequence));

	$fasta_file = 'tmp/'.$internal_id.'.fasta';

	open(FASTA, '>'.$fasta_file);
	print FASTA ">$internal_id\n";
	foreach $line(@nice_seq){
	print FASTA "$line\n";
	}
	close(FASTA);




	# call repeater and select for each of the repeats
	foreach $rep(keys %basic_name) {
	if ($debug eq 'this_is_a_secret') {
		print "<h5>.$rep.</h5>";
	}
	$neg_profile = 'data/'.$basic_name{$rep}.'_neg.prf';
	$pos_profile = 'data/'.$basic_name{$rep}.'_pos.prf';
	$for_file = 'data/'.$basic_name{$rep}.'_neg.for';
	$par_file = 'tmp/'.$internal_id.'.par';
	$sel_file = 'tmp/'.$internal_id.'.sel';

		if ($system eq 'mohamed'){
		$repeater_call = "./repeater.perl -neg $neg_profile -pos $pos_profile -d $fasta_file -mode search -for $for_file -thr 1e-2 > $par_file";
		if ($give_me_all == 1){
			$select_call = "./select.perl $par_file 1 1 1 10000";
		} else {
			$select_call = "./select.perl $par_file $e_value{$rep} $e_value{$rep} $min_rep{$rep} 10000";
		}
		} elsif ($system eq 'miguel_mainz') {
		$repeater_call = "/home/munoz/public_html/cgi-bin/rep/repeater.perl -neg $neg_profile -pos $pos_profile -d $fasta_file -mode search -for $for_file -thr 1e-2 > $par_file";
		if ($give_me_all == 1){
			$select_call = "/home/munoz/public_html/cgi-bin/rep/select.perl $par_file 1 1 1 10000";
		} else {
			$select_call = "/home/munoz/public_html/cgi-bin/rep/select.perl $par_file $e_value{$rep} $e_value{$rep} $min_rep{$rep} 10000";
		}

		}

	$repeater_call_output = `$repeater_call`;
	@select_lines = `$select_call`; 
	if ($debug eq 'this_is_a_secret') {
		print ":@select_lines:<br/>";
	}

	$counter = 2;
	foreach $line(@select_lines){

		if ($line =~ /^\#/) {
		next;
		}
		if ($counter > 0) {
		$counter--;
		next;
		}
		
		chop;
		@words = split(/\t/, $line);
		$evalue = $words[3];
		$score = $words[5];
		$from = $words[6];
		$to = $words[7];
		$frg = $words[8];

		$repeat_id = $rep.':'.$from.':'.$to.':'.$evalue.':'.$score;
		$repeat_list[$seq_number]{$repeat_id} = $frg;
		$position{$repeat_id} = $from;
	
	}
	#Moved inside here by Mohamed
	`rm $par_file`;

	}

	# delete last files
	#`rm $sel_file`;
	`rm $fasta_file`;

	#$ls = `ls`;

}
# output


if ($format eq "html") {
	print "Content-type: text/html\n\n";
}
if ($format eq "csv") {
	print "Content-type: text/plain\n\n";
}


$ls = `ls`;

# output

print $test;
if ($give_me_all == 1){
  print "<H3 style='color: red;'>WARNING!: No threshold was applied. Hits may not be true.</H3>\n";
}

#print "<TITLE>Results of a REP search</TITLE>\n";
if ($format eq "html") {
	print "<center><H3>Results of a REP search</H3></center>\n";
}
if ($debug eq 'this_is_a_secret') {
	print "<H1>$repeater_call</H1>\n";
	print "<H1>$select_call</H1>\n";
	print "<H1>-$repeat_list-</H1>\n";
}

if ($format eq "html") {
	print "<h4>Submitted sequence:</h4>\n";
	print "<div class='monospace-font'>\n";
	if ($seq_count == 1) {
		print $headers_complete[0] . "<br/>";
	}
}

for ($seq_number = 0; $seq_number < $seq_count; $seq_number++) {
	$rep_count = 0;
	foreach $properties(sort byposition keys %{$repeat_list[$seq_number]}){
		@words = split(/\:/, $properties);
		$ranges[$seq_number][$rep_count] = int($words[1]);
		$ranges[$seq_number][$rep_count + 1] = int($words[2]);
		$rep_count+=2;
	}
}


for ($seq_number = 0; $seq_number < $seq_count; $seq_number++) {
	$seq = $sequences[$seq_number];
	$char_pos = 1;
	$seq_pos = 0;
	$last_b = 0;
	$last_rep_pos = 0;
	$cur_output = 0;
	if ($seq_count > 1) {
		$output_line = $headers[$seq_number] . $white_spaces[$seq_number];
	} else {
		$output_line = "";
	}
	while ($seq =~ /(.)/g) {
		$b = 0;
		$i = 0;
		while(!$b && $i < $rep_count) {
			if (($char_pos >= $ranges[$seq_number][$i]) && ($char_pos <= $ranges[$seq_number][$i+1])) {
				$b = 1;
			} else {
				$i += 2;
			}
		}
		$rep_pos = $i/2;
		if ($b  && $last_b && $rep_pos != $last_rep_pos) {
			$output_line .= "</span>";
			$last_b = 0;
		}
		$last_rep_pos = $rep_pos;
		if ($b && !$last_b || ($seq_pos % 60) == 0) {
		    $bk = "bk" . $rep_pos % 7;
			$bkg = "bkg" . int($rep_pos / 7);

			$output_line .= "<span class=\"$bk $bkg\">";
			$last_b = 1;
		};
		if (!$b && $last_b) {
			$output_line .= "</span>";
			$last_b = 0;
		};
		$output_line .= $1;
		if ($b && ($seq_pos % 60) == 59) {
			$output_line .= "</span>";
			$last_b = 0;
		};
		$seq_pos++;
		if ($1 =~ /[a-zA-Z]/) {
			$char_pos++;
		}
		if (($seq_pos % 60) == 0) {
			$output_line .= "<br/>";
			$outputs[$cur_output] .= $output_line;
			$cur_output++;
			if ($seq_count > 1) {
				$output_line = $headers[$seq_number] . $white_spaces[$seq_number];
			} else {
				$output_line = "";
			}
		}
	}
	if (!$output_line == "") {
		if ($last_b) {
			$output_line .= "</span>";
			$last_b = 0;
		}
		$output_line .= "<br/>";
		$outputs[$cur_output] .= $output_line;
		$cur_output++;
		$output_line = "";
	}
}

if ($format eq "html") {
	foreach $output(@outputs) {
		print $output;
		if ($seq_count > 1) {print "<br/>"};
	}
	print "</div>";
}

if ($format eq "html") {
	print "<h4>Hits detected:</h4>\n";
	print "<div id=\"saveButton\" onclick=\"export_table_to_csv('', 'rep2-search-results.csv');\" class=\"btn btn-success\" style=\"float: right;\">Save as CSV</div><br/><br/>";
}
for ($seq_number = 0; $seq_number < $seq_count; $seq_number++) {
	
	if ($format eq "html"){
		print "<h5>Sequence " . ($seq_number + 1) . ": <span id='seq-name-$seq_number'>" . $headers[$seq_number] . "</span></h5>";
		print "<TABLE id='result-table-$seq_number' class='table table-striped table-bordered table-hover'>\n";
		print "<thead calss='thead-light'>";
		print "<TR scope='col'>\n"; 
		print "<TH>Repeat</TH><TH>From</TH><TH>To</TH><TH>Fragment</TH>\n";
		print "<TH>Score</TH>\n";
		unless ($give_me_all == 1){
			print "<TH>E-value</TH>";
		}

		print "</TR>\n";
		print "</thead>";

		$found = 0;
		$counter = 0;
		foreach $properties(sort byposition keys %{$repeat_list[$seq_number]}){
			$found = 1;
			@words = split(/\:/, $properties);
			$rep = $words[0];
			$from = $words[1];
			$to = $words[2];
			$evalue = $words[3];
			$score = $words[4];
			$fragment = $repeat_list[$seq_number]{$properties};
			print "<TR class='monospace-font'>\n";
			$bk = "bk" . $counter % 7;
			$bkg = "bkg" . int($counter / 7);
			
			print "<TD>$rep</TD><TD>$from</TD><TD>$to</TD><TD><span class=\"$bk $bkg\">$fragment<span/></TD>\n";
			print "<TD>$score</TD>\n";

			unless ($give_me_all == 1){
			print "<TD>$evalue</TD>\n";
			}
			print "</TR>\n";
			$counter++;
		}
	} 
	if ($format eq "csv"){
		if ($seq_number == 0) {
			print "Sequence name\tRepeat\tFrom\tTo\tFragment\tScore\tE-value\n";
		}
		
		foreach $properties(sort byposition keys %{$repeat_list[$seq_number]}){
			$found = 1;
			@words = split(/\:/, $properties);
			$rep = $words[0];
			$from = $words[1];
			$to = $words[2];
			$evalue = $words[3];
			$score = $words[4];
			$fragment = $repeat_list[$seq_number]{$properties};
			$fragment =~ s/\.//g;
			$fragment =~ s/\n//g;
			print $headers[$seq_number] . "\t$rep\t$from\t$to\t$fragment\t$score\t$evalue\n";
			unless ($give_me_all == 1){
			}
			#print "$fragment\n";
		}
	}



	if ($format eq "html"){
	print "</TR>\n";
		if ($found == 0) {
			print "<tr><td colspan='6'><center>No repeat detected</center></td></tr>\n";
		}
	print "</TABLE><P>";
	}
	if ($format eq "pre"){
		print "</PRE>\n";
		if ($found == 0) {
			print "No repeat detected<P>";
		}

	}
}


if ($format eq "html"){
	&html_bottom;
}




sub sub_error
  {
    &html_header;
    print "<H3>Error: $error</H3>\n";
    &html_bottom;
  }

sub html_header
  {
    print "Content-type: text/html\n\n";
    #print "<BODY BGCOLOR=#FFFFFF TEXT=#008800 LINK=#808800>\n";
  }

sub html_bottom
  {
    #print "<HR>\n";
    #print "<A HREF=http://www.embl-heidelberg.de/~andrade/papers/rep/>[Appendix Home]</A>\n";
    #print "<A HREF=http://www.embl-heidelberg.de/~andrade/index.html>[Andrade Home]</A>\n";
    #print "<A HREF=http://www.bork.embl-heidelberg.de/>[Bork Group]</A>\n";
    print "<br/>";
  }

sub byposition
  {
    $position{$a} <=> $position{$b}
  }
